#!/bin/perl

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#


#
# Avis au lecteur : merci d'etre indulgent, c'est mon premier jour de Perl...
#

#
# bon, d'accord : ces fichiers ont evolue, depuis mon premier jour de Perl...
#


# ce script utilise les fichiers suivants :
#
# nom : $TWSTOOLS/trees_to_browse.[dir,pag]
# type : hash des repertoires "physiques" a scruter, avec leurs chemins
#         equivalents (par rapport a 'http://server/')  et les proprietaires
#         (pour que les fichiers crees leur appartiennent...). Ce hash
#         contient egalement les sous-arborescences a EXCLURE de la
#         scrutation globale (pour ne pas faire exploser les tableaux !)
# usage : seule la 'cle' du hash est utilisee (les arborescences a scruter)
#
#


# ce script genere les fichiers suivants :
#
# nom : $TWSFILES/megalist_of_files
# type : liste de tous les fichiers connus de toutes les arborescences
#         a scruter, sans les sous-arborescences a exclure, mais avec
#         les fichiers des arborescences protegees par la directive '.keep'
# usage : permet de generer :
#          - list_of_linkspaths.[dir,pag]
#          - list_of_linkstitles.[dir,pag]
#          - list_of_images.[dir,pag]
#          - list_of_stuff.[dir,pag]
# format : chemin complet pour acceder au fichier, relatif a la racine
#           http du serveur Intranet (apres substitution des equivalences)
#
#
# nom : $TWSFILES/list_of_linkspaths.[dir,pag]
# type : hash des chemins des fichiers '.html'
# format : nom raccourci --> chemin complet (relatif)
#
#
# nom : $TWSFILES/list_of_linkstitles.[dir,pag]
# type : hash des titres des fichiers '.html'
# format : nom raccourci --> titre du fichier (relatif)
#
#
# nom : $TWSFILES/list_of_images.[dir,pag]
# type : hash des chemins des fichiers "image" '.gif', '.jpg', '.jpeg'
# format : nom raccourci --> chemin complet (relatif)
#
#
# nom : $TWSFILES/list_of_stuff.[dir,pag]
# type : hash des chemins des autres fichiers (ni HTML, ni image)
# format : nom raccourci --> chemin complet (relatif)
#
#
# nom : $TWSFILES/log_empty_titles
# type : liste de tous les fichiers '.html' qui n'ont pas de titre
#         (dont le nom de fichier est utilise comme titre, par defaut)
# format : chemin complet (relatif)
#
#
# nom : $TWSFILES/log_strange_titles
# type : liste de tous les fichiers '.html' qui ont un titre trop long
#         (dont le nom de fichier est utilise comme titre, par defaut)
# format : chemin complet (relatif)
#



# NOTE sur les chemins d'acces relatifs :
#  les chemins d'acces aux fichiers "physiques" (chemins classiques)
#  sont convertis en chemins d'acces relatifs , par rapport a la base exportee
#  par le serveur (en calir : 'http://server/').
#  Cette transformation est faite a partir des informations contenues dans
#  le hash 'trees_to_browse' (champ 'equivdir')
#


#
# NOTE : si on se donne la peine de generer des fichiers temporaires '_$$',
#  c'est pour pouvoir lancer un 'mkhtml' a la main pendant que ce script est
#  en train de tout casser...
#




require 5;
use Fcntl;
use ANYDBM_File;;


# la base de l'arborescence Intranet
$TWSROOT=$ENV{"TWSROOT"};
$TWSTOOLS=$ENV{"TWSTOOLS"};
$TWSFILES=$ENV{"TWSFILES"};
die "Variables \$TWS[TOOLS,FILES] non definies --> il faut sourcer '.twsrc'\n" if ($TWSROOT eq '' or $TWSTOOLS eq '' or $TWSFILES eq '');

# forcer le parcours des arborescences meme si les fichiers sont recents
$scanFiles=();
if($ARGV[0] =~ /force/i)
{
    $scanFiles=1;
}



# niveau de debug, pour les traces 'print XXX if $debug > N'
$debug=0;



# qui est il ?
$TWSROOTMASTER='root@calimero';
# faut il lui envoyer les erreurs par Mail ? ('true' ou '()' pour 'nil')
$Mail2WebMaster=();


# Longueur maximale d'un titre de document HTML
# Au dela, il est refuse, et le nom du fichier va dans 'log_too_long_titles'
$MAX_TITLE_LENGTH = 150;

# Longueur maximale de la partie 'value' dans un HASH ARRAY
# Sur SunOS, le 'ndbm' standard n'aime pas quand on debordre...
# En general, ce cas se produit pour les fichiers qui portent le MEME nom :
#  - filtrer les arborescences a ne PAS scruter avec 'manage_trees_to_browse'
#  - installer une DBM qui tient la route, par exemple BSD-DBM.
$MAX_SIZE_IN_HASH = 800;




# la "base" des arborescences (un bien grand mot pour un HASH ARRAY...)
$treeshash="$TWSFILES/list_of_trees";


# les fichiers, planques dans le repertoire '$TWSFILES'
$filesmegalist="$TWSFILES/megalist_of_files";
$linkspathsfilelist="$TWSFILES/list_of_linkspaths";
$linkstitlesfilelist="$TWSFILES/list_of_linkstitles";
$imagesfilelist="$TWSFILES/list_of_images";
$stufffilelist="$TWSFILES/list_of_stuff";


$tmpfilesmegalist="$TWSFILES/megalist_of_files_$$";
$tmplinkspathsfilelist="$TWSFILES/list_of_linkspaths_$$";
$tmplinkstitlesfilelist="$TWSFILES/list_of_linkstitles_$$";
$tmpimagesfilelist="$TWSFILES/list_of_images_$$";
$tmpstufffilelist="$TWSFILES/list_of_stuff_$$";

$listerrfile1="$TWSFILES/log_empty_titles";
$listerrfile2="$TWSFILES/log_strange_titles";



# la liste de toutes les arborescences a parcourir

# 0 = pas de masque de creation
tie(%trees, SDBM_File, $treeshash, O_READONLY, 0) or die "(fatal:make_txt2html_files:$treeshash)\n";

# charger le HASH 'equivelences{chemins}' et le tableau des arborescences
#  a exclure
foreach $tree (keys(%trees))
{
    my $equiv, $bof;

    ($equiv, $bof) = split(/\n/, $trees{$tree});

    if($equiv eq 'exclude')
    {
	print "exclude : $tree\n";
	push(@excludedtrees, $tree);
    }
    else
    {
	$equivdirs{$tree} = $equiv;
    }
}

untie(%trees);


# debug REGEXP in excludes
#if('FALSE')
#{
#    foreach $tree (@excludedtrees)
#    {
#	# il FAUT preciser 'next LINE' pour sortir de DEUX boucles d'un coup...
#	
#	print "MATCH "  if m|^$tree|;
#    }#
#
#    die "gasp !\n";
#}


# creer la liste de tous les fichiers
# (refaire le fichier si il n'a pas ete modifie depuis au moins 0,8 jour)
# (sinon, effacer le fichier 'megalist' pour forcer sa creation)
if((! -e $filesmegalist) || (-C $filesmegalist > 0.8) || ($scanFiles))
{
    # effacer le fichier si il existe
    unlink $tmpfilesmegalist;

    # parcourir toutes les arborescences
    foreach $tree (keys(%equivdirs))
    {
	# laisser les traces pour montrer que ca va prendre un certain temps...
       	print "find $tree ! -type d -print >> $filesmegalist\n...";
	system "find $tree ! -type d -print >> $tmpfilesmegalist";
	print " done.\n";
    }

    rename $tmpfilesmegalist, $filesmegalist;
}
else
{
    print " - liste recente -> non refaite.\n";
    print " - effacer '$filesmegalist' si necessaire.\n";
}



# on ouvre la liste 'en vrac', puis on dispatche les bouts selon...

# on profite de la boucle pour filtrer 'megalist_of_files' dans 'OUTFILES'
open(INFILES, "< $filesmegalist");
open(OUTFILES, "> $tmpfilesmegalist");

# ouverture / creation des HASH ARRAYS

# 0666 && !umask = masque de creation (066 -> rw-r--r-- si umask = 022)
tie(%linkspaths, SDBM_File, $tmplinkspathsfilelist, O_CREAT | O_RDWR, 0666);
tie(%linkstitles, SDBM_File, $tmplinkstitlesfilelist, O_CREAT | O_RDWR, 0666);
tie(%images, SDBM_File, $tmpimagesfilelist, O_CREAT | O_RDWR, 0666);
tie(%stuff, SDBM_File, $tmpstufffilelist, O_CREAT | O_RDWR, 0666);


# ca peut toujours servir, les erreurs...
# ... si on se donne la peine d'y jetter un oeil...
open(ERROR_EMPTY, "> $listerrfile1");
open(ERROR_TOO_LONG, "> $listerrfile2");


 LINE: 
    while($_ = <INFILES>)
{
    chomp $_;
    
    # filtrer les repertoires 'cap/aufs'
    next if /\.finderinfo/;  
    next if /\.resource/;

    # filtrer les 'backup files'
    next if /~$/;
    next if /_$/;
    next if /%$/;
    next if /.bak$/;

    # filter les fichiers sans valeur ajoutee
    next if /index\.auto$/;
    next if /\/index\.html*$/;
    next if /files\.html$/;
    next if /\.header$/;
    next if /\.header\.html$/;
    next if /\.footer$/;
    next if /\.footer\.html$/;
    next if /\.keep$/;
    next if /\.lnk$/;


    # purger violemment tout se qui se trouve sous les 'exclude trees'
    foreach $tree (@excludedtrees)
    {
	# il FAUT preciser 'next LINE' pour sortir de DEUX boucles d'un coup...

	next LINE if m|^$tree|;
    }

    # on doit conserver le chemin absolu sous le coude pour le titre HTML...
    $abspath=$_;

    # ...mais on doit "relativiser", par rapport a 'http://bunny.pf/'
    foreach $tree (keys(%equivdirs))
    {
	last if s|^$tree|$equivdirs{$tree}|;
    }

    print "[$abspath][$_]\n" if $debug > 50;


    # sauver la version purgee, histoire de reduire un peu le fichier
    print OUTFILES "$abspath\n";



    if (/\.html$/ or /\.htm$/)
    {
	undef $filetitle;

	# extrait le nom_raccourci a partir du chemin_complet
	$filename = $_;
	$filename =~ s/^.*\/(.*)\.htm[l]*$/$1/;
	
	# va chercher le titre dans ce fichier
	$save_IRS = $/;
	undef $/;
	open(FILE, "< $abspath");
	$big = <FILE>;     # tout le fichier dans '$big', merci Perl...
	if($big =~ /<title>(.*)<\/title>/is) {$filetitle=$+};
	close(FILE);
	undef $big;
	$/ = $save_IRS;
	
	# y a t il un titre au numero que vous avez demande ?
	chomp $filetitle;
	if($filetitle eq '')
	{
	    # un titre de substitution...
	    print "'$filename' n'a pas de titre\n" if $debug > 10;
	    $filetitle = $filename;
	    print ERROR_EMPTY "$_\n";
	    }
	else
	{
	    if(length($filetitle) > $MAX_TITLE_LENGTH)
	    {
		# un titre de substitution...
		print "'$filename' a un titre trop long (",length($filetitle),")\n" if $debug > -10;
		print "[[$filetitle]]\n";
		$filetitle = $filename;

		print ERROR_TOO_LONG "$_\n";
	    }
	    # else ca a l'air normal, comme titre...
	}
	

	# ajoute les infos dans le HASH des fichiers 'LINKABLES'
	$current_infos = $linkspaths{$filename}; # en general, c'est vide...
	# mais ca peutr aussi deborder... 
 	$lg_current_infos = length($current_infos);
	if($lg_current_infos > $MAX_SIZE_IN_HASH)
	{
	    print "debordement pour '$filename' -> ce champ sera mis a la poubelle\n";
	    push (@stuff_to_delete, $filename);
	}
	else
	{
	    $linkspaths{$filename} = "$_\n$current_infos";
	}

	$current_infos = $linkstitles{$filename}; # en general, c'est vide...
	$lg_current_infos = length($current_infos);
	if($lg_current_infos > $MAX_SIZE_IN_HASH)
	{
	    print "debordement pour '$filename' -> ce champ sera mis a la poubelle\n";
	    push (@stuff_to_delete, $filename);
	}
	else
	{
	    $linkstitles{$filename} = "$filetitle\n$current_infos";
	}


	print "$filename = [$linkspaths{$filename}][$linkstitles{$filename}]\n" if $debug > 12;

	next;
    }
    
    if(/\.gif/i or /\.jpg/i or /\.jpeg/i)
    {
	# extrait le nom_raccourci a partir du chemin_complet
	$filename = $_;
	$filename =~ s/^.*\/(.*)$/$1/;   # ce qu'il y a apres le dernier '/'
	$filename =~ s/(.*)\..*/$1/;     # ce qu'il y a avant le dernier '.'
	

 	# ajoute les infos dans le HASH des images
 	$current_infos = $images{$filename};   # en general, c'est vide...

	# mais ca peutr aussi deborder... 
 	$lg_current_infos = length($current_infos);
	if($lg_current_infos > $MAX_SIZE_IN_HASH)
	{
	    print "debordement pour '$filename' -> ce champ sera mis a la poubelle\n";
	    push (@stuff_to_delete, $filename);
	}
	else
	{
	    $images{$filename} = "$_\n$current_infos";
	}

	next;
    }

    
    # ce qui reste, c'est le "bordel ambiant" (shocking !....)
    $filename = $_;
    $filename =~ s/^.*\/(.*)$/$1/;   # ce qu'il y a apres le dernier '/'

    
    # ajoute les infos dans le HASH des bric-a-bracs
    $current_infos = $stuff{$filename}; # en general, c'est vide...
    
    # sauf si la taille explose --> on poubellise car ca ne doit pas
    # etre utile a grand chose...
    $lg_current_infos = length($current_infos);
    if($lg_current_infos > $MAX_SIZE_IN_HASH)
    {
 	print "debordement pour '$filename' -> ce champ sera mis a la poubelle\n";
 	push (@stuff_to_delete, $filename);
    }
    else
    {
 	$stuff{$filename} = "$_\n$current_infos";
    }
    
    print "$filename = ($lg_current_infos)[$_\n$current_infos]\n" if $debug > 12;
    
}



# suppression de tous les champs qui 'debordent' anormalement
while($key = pop(@stuff_to_delete))
{
    print "Suppress key '$key' in STUFF hash array\n";
    delete $stuff{$key};
}

untie(%linkspaths);
untie(%linkstitles);
untie(%images);
untie(%stuff);


rename "$tmplinkspathsfilelist.dir",  "$linkspathsfilelist.dir";
rename "$tmplinkspathsfilelist.pag",  "$linkspathsfilelist.pag";
rename "$tmplinkstitlesfilelist.dir",  "$linkstitlesfilelist.dir";
rename "$tmplinkstitlesfilelist.pag",  "$linkstitlesfilelist.pag";
rename "$tmpimagesfilelist.dir", "$imagesfilelist.dir";
rename "$tmpimagesfilelist.pag", "$imagesfilelist.pag";
rename "$tmpstufffilelist.dir",  "$stufffilelist.dir";
rename "$tmpstufffilelist.pag",  "$stufffilelist.pag";


#
# autoriser tout le monde a ajouter des entrees dans les tableaux associatifs,
#  via 'add_txt2html_files.pl'
chmod 0666, "$linkspathsfilelist.dir", "$linkspathsfilelist.pag";
chmod 0666, "$linkstitlesfilelist.dir", "$linkstitlesfilelist.pag";
chmod 0666, "$imagesfilelist.dir", "$imagesfilelist.pag";
chmod 0666, "$stufffilelist.dir", "$stufffilelist.pag";



# fermeture des 'mega_lists_of_files' avant purge...
close(INFILES);
close(OUTFILES);

# on gagne pas mal de place avec cette purge (environ 35%)
unlink $filesmegalist;
rename $tmpfilesmegalist, $filesmegalist;



close(ERROR_EMPTY);
close(ERROR_TOO_LONG);



# Envoyer un Mail au WebMaster si on a trouve des fichiers sans titre
if($Mail2WebMaster)
{
    if (-s $listerrfile1)
    {
	# envoi d'un petit message d'amour a 'WebMaster'

	$nb_lines=`wc -l $listerrfile1 | awk '{print $1}'`;

	if($nb_lines > 0)
	{
	    system "Mail -s \"txt2html : EMPTY titles\" $TWSROOTMASTER < $listerrfile1";
	}
    }
    
    if (-s $listerrfile2)
    {
	$nb_lines=`wc -l $listerrfile2 | awk '{print $1}'`;
	
	if($nb_lines > 0)
	{
	    system "Mail -s \"txt2html : STRANGE titles\" $TWSROOTMASTER < $listerrfile2";
	}
    }
}





